<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng</h2>
    </div>

    <table id="table-users" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
  
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      }     
    ]
  }`;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function() {
      onPageLoading();

      // gán sự kiện cho các nút detail button
      $(".user-detail").on("click", function() {
        onBtnDetailButtonClick(this);
      });
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      var vUserObj = JSON.parse(gJsonUser);
      // load dữ liệu vào bảng users
      loadUsersDataToTable(vUserObj.users);
    }

    // hàm xử lý sự kiện nút chi tiết ấn
    function onBtnDetailButtonClick(paramDetailButton) {
      console.log("Nút chi tiết được ấn");
      var vUserId = $(paramDetailButton).data("userid");
      var vFirstname = $(paramDetailButton).data("firstname");
      var vLastname = $(paramDetailButton).data("lastname");
      var vAge = $(paramDetailButton).data("age");

      console.log("userid: " + vUserId);
      console.log("firstname: " + vFirstname);
      console.log("lastname: " + vLastname);
      console.log("age: " + vAge);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm load dữ liệu mảng users vào bảng
    // đầu vào: mảng dữ liệu người dùng
    // $(selector).action()
    function loadUsersDataToTable(paramUsers) {
      var vUserTable = $("#table-users");
      for(var bI = 0; bI < paramUsers.length; bI ++) {
        var bNewRow = $("<tr>").appendTo(vUserTable);
        // tạo ra ô mới, gắn vào dòng + điền dữ liệu innerHTML cho ô
        $("<td>", { html: paramUsers[bI].userId }).appendTo(bNewRow);
        $("<td>", { html: paramUsers[bI].firstname }).appendTo(bNewRow);
        $("<td>", { html: paramUsers[bI].lastname }).appendTo(bNewRow);
        $("<td>", { html: paramUsers[bI].age }).appendTo(bNewRow);
        
        var bActionCell = $("<td>").appendTo(bNewRow);
        var bDetailButton = $("<button>", {
          html: "Chi tiết", 
          class: "btn btn-primary user-detail" 
        }).data("userid", paramUsers[bI].userId)
        .data("firstname", paramUsers[bI].firstname)
        .data("lastname", paramUsers[bI].lastname)
        .data("age", paramUsers[bI].age)
        .appendTo(bActionCell);
      }
    }  
  </script>
</body>

</html>
​